import unit4.collectionsLib.*;


public class Vector<T> 
{
	private List<T> list;
	private int numOfItems;

	public Vector() 
	{
		this.list = new List<T>();
		this.numOfItems = 0;
	}
	
	public void add(T x)
	{
		this.list.insert(null, x);
		this.numOfItems++;
	}
	
	public void del(int place)
	{
		this.list.remove(this.getItemPos(place));			
		this.numOfItems--;
	}
	
	public T get(int place)
	{
		return(this.getItemPos(place).getInfo());
	}
	
	public void set(int place, T x)
	{	
		this.getItemPos(place).setInfo(x);
	}

	public int length()
	{
		return(this.numOfItems);
	}
	
	public String toString()
	{
		Stack<T> stk = new Stack<T>();
		Node<T> pos = this.list.getFirst();
		
		while(pos != null)
		{
			stk.push(pos.getInfo());
			pos = pos.getNext();
		}
		
		String str = "";
		
		if(!stk.isEmpty())
			str = str + stk.pop();
		while(!stk.isEmpty())
			str = str + "," + stk.pop();
		
		return(str);
	}
	
	// :     
	private Node<T> getItemPos(int place)
	{
		Node<T> pos = this.list.getFirst();
		
		for(int i=1; i<=this.numOfItems-place; i++) 
			pos = pos.getNext();
		
		return(pos);
	}
}
